/******************************************************************************
 *
 *                Copyright (c) 2017-2019 by Löwenware Ltd
 *             Please, refer LICENSE file for legal information
 *
 ******************************************************************************/

/**
 * @file list.h
 * @author Ilja Kartašov <ik@lowenware.com>
 * @brief List module header file
 *
 * @see https://lowenware.com/
 */

#ifndef AISL_LIST_H_21495B65_111D_40F7_840F_CC50D9D324A1
#define AISL_LIST_H_21495B65_111D_40F7_840F_CC50D9D324A1

#include <stdint.h>

#define LIST_INDEX(L, I) ( L.data[ I ] )


struct list
{
    void   ** data;
    int32_t   size;
    int32_t   count;
};

typedef struct list * list_t;


typedef void
(* list_destructor_t)(void * list_item);


int32_t
list_init(list_t list, int32_t size);


void
list_release(list_t list, list_destructor_t destructor);


int32_t
list_append(list_t list, void * entry);


void *
list_remove_index(list_t list, int32_t index);


#endif /* !AISL_LIST_H */
